# IterableFileSet

Extends \FileSet Implements \IteratorAggregate

FileSet adapter to SPL's Iterator.

TODO:

- merge this with patternsets: FileSet extends PatternSet !!! requires additional mods to the parsing algo [HL] .... not sure if that really makes so much sense. I think that perhaps they should use common utility class if there really is that much shared functionality

package | phing.types
author | Alexey Shockov alexey@shockov.com
since | 2.4.0
internal |

### Methods

## Return a FileSet that has the same basedir and same patternsets as this one.

    __clone()

inherited

## __construct

    __construct(null $fileset = null)

inherited

### Arguments

#### $fileset

`null`

## Add a new selector into this container.

    appendSelector(\FileSelector $selector) : void

inherited

throws |

### Arguments

#### $selector

`\FileSelector`

new selector to add

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## add an "And" selector entry on the selector list

    createAnd() : \AndSelector

inherited

### Response

`\AndSelector`

## add a contains selector entry on the selector list

    createContains()

inherited

## add a contains selector entry on the selector list

    createContainsRegexp()

inherited

## add an extended selector entry on the selector list

    createCustom()

inherited

## add a selector date entry on the selector list

    createDate()

inherited

## add a depends selector entry on the selector list

    createDepend()

inherited

## add a depth selector entry on the selector list

    createDepth()

inherited

## add a different selector entry on the selector list

    createDifferent()

inherited

## add a name entry on the exclude list

    createExclude()

inherited

## add a name entry on the include files list

    createExcludesFile()

inherited

## add a selector filename entry on the selector list

    createFilename()

inherited

## add a name entry on the include list

    createInclude()

inherited

## add a name entry on the include files list

    createIncludesFile()

inherited

## add a majority selector entry on the selector list

    createMajority()

inherited

## add a "None" selector entry on the selector list

    createNone()

inherited

## add a "Not" selector entry on the selector list

    createNot()

inherited

## add an "Or" selector entry on the selector list

    createOr() : \OrSelector

inherited

### Response

`\OrSelector`

## createPatternSet

    createPatternSet() : mixed

inherited

throws |

### Response

`mixed`

## add a present selector entry on the selector list

    createPresent()

inherited

## add a readable selector entry on the selector list

    createReadable()

inherited

## add a "Select" selector entry on the selector list

    createSelector() : \SelectSelector

inherited

### Response

`\SelectSelector`

## add a selector size entry on the selector list

    createSize()

inherited

## add a type selector entry on the selector list

    createType()

inherited

## add a writable selector entry on the selector list

    createWritable()

inherited

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## getDir

    getDir(\Project $p) : mixed

inherited

throws |

### Arguments

#### $p

`\Project`

### Response

`mixed`

## returns a reference to the dirscanner object belonging to this fileset

    getDirectoryScanner(\Project $p) : \DirectoryScanner

inherited

throws |

### Arguments

#### $p

`\Project`

### Response

`\DirectoryScanner`

## getFiles

    getFiles() : array

### Response

`array`

## getIterator

    getIterator() : \Iterator

### Response

`\Iterator`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Performs the check for circular references and returns the referenced FileSet.

    getRef(\Project $p) : \FileSet

inherited

throws |

### Arguments

#### $p

`\Project`

### Response

`\FileSet`

## Returns the set of selectors as an array.

    getSelectors(\Project $p) : array

inherited

throws |

### Arguments

#### $p

`\Project`

### Response

`array`

of selectors in this container

## Indicates whether there are any patterns here.

    hasPatterns() : boolean

inherited

### Response

`boolean`

Whether any patterns are in this container.

## Indicates whether there are any selectors here.

    hasSelectors() : boolean

inherited

### Response

`boolean`

Whether any selectors are in this container

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## pushAndInvokeCircularReferenceCheck

    pushAndInvokeCircularReferenceCheck(\DataType $dt,  &$stk, \Project $p)

inherited static

### Arguments

#### $dt

`\DataType`

#### $stk

``

#### $p

`\Project`

## Gives the count of the number of selectors in this container

    selectorCount() : integer

inherited

throws |

### Response

`integer`

The number of selectors in this container

## Returns an array for accessing the set of selectors.

    selectorElements() : array

inherited

### Response

`array`

The array of selectors

## Sets case sensitivity of the file system

    setCaseSensitive( $isCaseSensitive)

inherited

### Arguments

#### $isCaseSensitive

``

## Sets whether default exclusions should be used or not.

    setDefaultexcludes( $useDefaultExcludes) : void

inherited

throws |

### Arguments

#### $useDefaultExcludes

``

"true"|"on"|"yes" when default exclusions should be used, "false"|"off"|"no" when they shouldn't be used.

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## setDir

    setDir( $dir)

inherited

throws |

### Arguments

#### $dir

``

## Sets the set of exclude patterns. Patterns may be separated by a comma or a space.

    setExcludes( $excludes)

inherited

throws |

### Arguments

#### $excludes

``

## Sets the name of the file containing the includes patterns.

    setExcludesfile( $excl)

inherited

throws |

### Arguments

#### $excl

``

The file to fetch the exclude patterns from.

## Sets whether to expand/dereference symbolic links, default is false

    setExpandSymbolicLinks( $expandSymbolicLinks)

inherited

var |

### Arguments

#### $expandSymbolicLinks

``

## setFile

    setFile(\PhingFile $file)

inherited

### Arguments

#### $file

`\PhingFile`

## Sets the set of include patterns. Patterns may be separated by a comma or a space.

    setIncludes( $includes)

inherited

throws |

### Arguments

#### $includes

``

## Sets the name of the file containing the includes patterns.

    setIncludesfile(\PhingFile $incl)

inherited

throws |

### Arguments

#### $incl

`\PhingFile`

The file to fetch the include patterns from.

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## feed dirscanner with infos defined by this fileset

    setupDirectoryScanner(\DirectoryScanner $ds, \Project $p)

inherited

throws |

### Arguments

#### $ds

`\DirectoryScanner`

#### $p

`\Project`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

### Properties

## useDefaultExcludes

    useDefaultExcludes : boolean

inherited

var |

### Type(s)

`boolean`

## Whether to expand/dereference symbolic links, default is false

    expandSymbolicLinks : boolean

inherited

var |

### Type(s)

`boolean`

## defaultPatterns

    defaultPatterns : \PatternSet

inherited

var |

### Type(s)

`\PatternSet`

## additionalPatterns

    additionalPatterns :

inherited

### Type(s)

``

## dir

    dir :

inherited

### Type(s)

``

## isCaseSensitive

    isCaseSensitive :

inherited

### Type(s)

``

## selectors

    selectors :

inherited

### Type(s)

``

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`